/*
	bows2() - draws bowties - requires BGI graphics system
	bows3() - draws bowties - requires BGI graphics system
	bows4() - draws bowties - requires BGI graphics system
*/

#include <graphics.h>
#include <math.h>
#include <stdlib.h>
#include <conio.h>

extern	step,
	keyhit(void),
	newfill(int),
	quadrant(int,int,int,int);


int bows2(int x1,int y1,int x2,int y2) /* crooked bowties */
{
  struct pixel	{ int x, y; }	tri[4];
  int   oldx1,
	oldx2,
	x1step,
	x2step,
	minx=min(x1,x2),
	miny=min(y1,y2),
	maxx=max(x1,x2),
	maxy=max(y1,y2),
	midx=(x1+x2)>>1,
	midy=(y1+y2)>>1;

  if(abs(x1-x2)<step)
    return;
  switch(step)
  {
    case 1:   newfill(step);
	      tri[0].x=midx;
	      tri[0].y=midy;
	      tri[3].x=midx;
	      tri[3].y=midy;
	      switch(quadrant(x1,y1,x2,y2))
	      {
		 case 1: tri[1].x=minx;	tri[1].y=miny;
			 tri[2].x=midx;	tri[2].y=miny;
			 fillpoly(4,(int far *)tri);
			 tri[1].x=maxx;	tri[1].y=maxy;
			 tri[2].x=midx;	tri[2].y=maxy;
			 break;
		 case 2: tri[1].x=maxx;	tri[1].y=miny;
			 tri[2].x=midx;	tri[2].y=miny;
			 fillpoly(4,(int far *)tri);
			 tri[1].x=minx;	tri[1].y=maxy;
			 tri[2].x=midx;	tri[2].y=maxy;
			 break;
		 case 3: tri[1].x=minx;	tri[1].y=miny;
			 tri[2].x=midx;	tri[2].y=miny;
			 fillpoly(4,(int far *)tri);
			 tri[1].x=maxx;	tri[1].y=maxy;
			 tri[2].x=midx;	tri[2].y=maxy;
			 break;
		 case 4: tri[1].x=maxx;	tri[1].y=miny;
			 tri[2].x=midx;	tri[2].y=miny;
			 fillpoly(4,(int far *)tri);
			 tri[1].x=minx;	tri[1].y=maxy;
			 tri[2].x=midx;	tri[2].y=maxy;
			 break;
		 case 5: return;
	      }
	      fillpoly(4,(int far *)tri);
	      break;
    default:  /* step != 1 */
	      oldx1=x1;
	      oldx2=x2;
	      x1step=(x1<x2)?step:-step;
	      x2step=-x1step;
	      while(abs(x1-x2)>step)
	      {
		 line(x1,y1,x2,y2);
		 x1+=x1step;
		 x2+=x2step;
		 if(kbhit()) keyhit();
	      }
	      line(x1-x1step,y1,oldx1,y1);
	      line(x2-x2step,y2,oldx2,y2);
	      break;
  }
}


int bows3(int x1,int y1,int x2,int y2) /* crooked bowties */
{
  int	dy,midy=(y1-y2)/(step+1);

  if(y1==y2)
    return;
  if(y1<y2)
    for(dy=0;dy<=midy;dy+=step)
    {
      line(x1,y1+dy,x2,y2-dy);
      if(kbhit()) keyhit();
    }
  else
    for(dy=0;dy<midy;dy+=step)
    {
      line(x1,y1-dy,x2,y2+dy);
      if(kbhit()) keyhit();
    }
}


int bows4(int x1,int y1,int x2,int y2) /* bowties */
{
  int	y1step=(y1<y2)?1:-1,
	y2step=-y1step;

  while(abs(y1-y2)>1)
  {
    line(x1,y1,x2,y2);
    line(x1,y2,x2,y1);
    y1+=y1step;
    y2+=y2step;
    if(kbhit()) keyhit();
  }
}

