/*
	curve1() - draws a complex shape based on many parameters
*/

#include <graphics.h>
#include <math.h>
#include <conio.h>
#include <stdlib.h>

extern	keyhit(void);


int curve1(int x1,int y1,int x2,int y2)
{
  int	count=9,
	col=getcolor();
  float	a,x,y,
	astart=0,
	astep=M_PI/300.0,
	aend=M_PI/2.0,
	midx=(x1+x2)/2.0,
	midy=(y1+y2)/2.0,
	xmult=midx-min(x1,x2),
	ymult=midy-min(y1,y2);

  for(a=astart; a<=aend; a+=astep)
  {
    if(kbhit()) keyhit();
    x=xmult*sin(a+M_PI/8.0);
    y=ymult*cos(a);
    if(++count==10)
    {
      line(midx+x, midy+y, midx, midy);
      line(midx-x, midy+y, midx, midy);
      line(midx-x, midy-y, midx, midy);
      line(midx+x, midy-y, midx, midy);
      count=0;
    }
    else
    {
      putpixel(midx+x, midy+y, col);
      putpixel(midx-x, midy+y, col);
      putpixel(midx-x, midy-y, col);
      putpixel(midx+x, midy-y, col);
    }
  }
}
