/*
	fans1() - draws a 90-degree sweep, resembling a fan.
	Suspends an XOR_PUT writemode until return.
*/

#include <graphics.h>
#include <conio.h>

extern	step,
	writemode,
	quadrant(int,int,int,int),
	keyhit(void);


int fans1(int x1,int y1,int x2,int y2)
{
  int	i,
	s=step+1;

  setwritemode(0);		/* disallow XOR_PUT writemode */
  switch(quadrant(x1,y1,x2,y2))
  {
    case 1:  for(i=x1;i<=x2;i+=s)
	       line(i,y1,x2,y2);
	     if(kbhit())
	       keyhit();
	     for(i=y1;i<=y2;i+=s)
	       line(x1,i,x2,y2);
    case 2:  for(i=x1;i>=x2;i-=s)
	       line(i,y1,x2,y2);
	     if(kbhit())
	       keyhit();
	     for(i=y1;i<=y2;i+=s)
	       line(x1,i,x2,y2);
    case 3:  for(i=x1;i>=x2;i-=s)
	       line(i,y1,x2,y2);
	     if(kbhit())
	       keyhit();
	     for(i=y1;i>=y2;i-=s)
	       line(x1,i,x2,y2);
    case 4:  for(i=x1;i<=x2;i+=s)
	       line(i,y1,x2,y2);
	     if(kbhit())
	       keyhit();
	     for(i=y1;i>=y2;i-=s)
	       line(x1,i,x2,y2);
    case 5: return;
  }
  setwritemode(writemode);	/* reset to entry condition */
}
