/*
	quadrant() - returns values 1-5 depending on the relative locations
	of the two points passed to it.
*/

int quadrant(int x1,int y1,int x2,int y2)
{
  if((x1<x2)&&(y1<y2))	/*-------*/
    return(1);		/* 1     */
			/*   \   */
			/*     2 */
			/*-------*/

  if((x1>x2)&&(y1<y2))	/*-------*/
    return(2);		/*     1 */
			/*   /   */
			/* 2     */
			/*-------*/

  if((x1>x2)&&(y1>y2))	/*-------*/
    return(3);		/* 2     */
			/*   \   */
			/*     1 */
			/*-------*/

  if((x1<x2)&&(y1>y2))	/*-------*/
    return(4);		/*     2 */
			/*   /   */
			/* 1     */
			/*-------*/

  return(5);		/* x1==x2 and/or y1==y2 */
}
