/*
	shiftpal() - shifts values of all colors in current palette by
		     prescribed number of steps
*/

#include <graphics.h>


int shiftpal(int amount)
{
  struct palettetype	p;
  int	i,j,c;

  getpalette(&p);
  if(amount>0)			/* forward */
    for(j=1;j<=amount;j++)
    {
      c=p.colors[p.size-1];	/* save value of highest color */
      for(i=p.size-1;i>=1;i--)
	p.colors[i]=p.colors[i-1];
      p.colors[0]=c;		/* put saved value into lowest */
    }
  else				/* reverse */
    for(j=1;j<=-amount;j++)
    {
      c=p.colors[0];		/* save value of lowest color */
      for(i=0;i<p.size-1;i++)
	p.colors[i]=p.colors[i+1];
      p.colors[p.size-1]=c;	/* put saved value into highest */
    }
  setallpalette(&p);
}
