/*
	screenoff() - blanks the screen while drawing
	screenon() - turns screen back on after call to screenoff()
*/

#pragma inline

int screenoff(void)
{
  int returnvalue;
  asm {
    mov ax,0x1201
    mov bl,0x36;		/* "toggle screen" subfunction */
    int 0x10
    mov [returnvalue],al;	/* 0x12 if valid */
  }
}


int screenon(void)
{
  int returnvalue;

  asm {
    mov ax,0x1200
    mov bl,0x36;		/* "toggle screen" subfunction */
    int 0x10
    mov [returnvalue],al;	/* 0x12 if valid */
  }
}
