/*
	bichrome() - sets the entire color palette to alternating 2 colors
	Requires BGI graphics system.
*/

#include <graphics.h>

int bichrome(int color1,int color2)
{
  struct palettetype	p;
  int			i;

  getpalette(&p);
  for(i=0;i<p.size;i+=2)
  {
    p.colors[i]=color1;
    p.colors[i+1]=color2;
  }
  setallpalette(&p);
}
