/*
	frame1() - draws a curved frame using only straight lines
	frame2() - draws a curved frame using only straight lines
	Requires BGI
*/

#include <graphics.h>
#include <conio.h>
#include <stdlib.h>

extern	step,
	mwleft,mwtop,mwright,mwbottom,
	writemode,
	restart,
	keyhit(void);


int frame1(void)
{
  int z;

  if(writemode)
    step=1+random(3);
  for(z=mwtop;z<=mwbottom;z+=step)
  {
    line(mwleft,z,z,mwbottom);
    line(mwright,z,mwbottom-z,mwbottom);
    line(mwleft,mwbottom-z,z,mwtop);
    line(mwright,mwbottom-z,mwright-z,mwtop);
    if(kbhit())
      keyhit();
  }
  restart=1;
}


int frame2(void)
{
  int	x,
	mid=(mwright-mwleft)>>1;

  if(writemode)
    step=1+random(3);
  for(x=mwleft;x<mid;x+=step)
  {
    line(x,mwtop,mwleft,mid-x);
    line(mwright-x,mwtop,mwright,mid-x);
    line(x,mwbottom,mwleft,mid+x);
    line(mwright-x,mwbottom,mwright,mid+x);
    if(kbhit())
      keyhit();
  }
  restart=1;
}
